// Cyphesis Online RPG Server and AI Engine
// Copyright (C) 2009 Alistair Riddoch
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

// $Id: 1b1b8c788a0a52934288ceefdbb8216ea7fd2e95 $

#include "CommStreamListener.h"

#include "CommClientFactory.h"

#include <skstream/skserver.h>

/// \brief Constructor for stream listener socket object.
///
/// @param svr Reference to the object that manages all socket communication.
CommStreamListener::CommStreamListener(CommServer & svr, CommClientKit & kit) :
                    CommSocket(svr), m_clientKit(kit)
{
}

CommStreamListener::~CommStreamListener()
{
    delete &m_clientKit;
}

int CommStreamListener::create(int asockfd, const char * address)
{
    return m_clientKit.newCommClient(m_commServer, asockfd, address);
}

int CommStreamListener::getFd() const
{
    return m_listener->getSocket();
}

bool CommStreamListener::eof()
{
    return false;
}

bool CommStreamListener::isOpen() const
{
    return m_listener->is_open();
}

int CommStreamListener::read()
{
    accept();
    // Accept errors are not returned, as the listen socket should not
    // be removed.
    return 0;
}

void CommStreamListener::dispatch()
{
}
