// Cyphesis Online RPG Server and AI Engine
// Copyright (C) 2006 Alistair Riddoch
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

// $Id: 27904697fd8aca77754c22879ac69d3c0f1669d6 $

#ifndef SERVER_IDLE_PSQL_CONNECTOR_H
#define SERVER_IDLE_PSQL_CONNECTOR_H

#include "Idle.h"

#include <time.h>

class Database;

/// \brief Handle attempting to reconnect to the RDBMS if we lose connection.
class IdlePSQLConnector : virtual public Idle {
  protected:
    Database & m_db;

    long m_lastConnect;
  public:
    IdlePSQLConnector(CommServer &, Database &);
    virtual ~IdlePSQLConnector();

    virtual void idle(time_t t);
};

#endif // SERVER_IDLE_PSQL_CONNECTOR_H
